<template>
  <div class="modal">
    <div class="modal-overlay" @click="$emit('close')"></div>
    <div class="modal-content">
      <div class="header">
        <div class="header-title">{{$props.title}}</div>
        <div class="header-menu" v-if="$props.menuItems">
          <div class="menu-divider"></div>
          <wp-dropdown v-model="activeMenu" :items="$props.menuItems"
            :modifiers="$props.menuModifiers"/>
        </div>
        <button class="header-action"
          @click="$emit('close')">
          <font-awesome-icon icon="times" class="action-close" size="lg"/>
        </button>
      </div>
      <div class="content">
        <slot v-if="activeMenu" :name="activeMenu"/>
        <slot v-else name="default"/>
      </div>
    </div>
  </div>
</template>

<script>
import WpDropdown from '@/components/input/WpDropdown.vue';

export default {
  name: 'Modal',
  components: {
    WpDropdown,
  },
  props: {
    title: {
      type: String,
      default: '',
    },
    menuItems: {
      type: Array,
      default: undefined,
    },
    menuModifiers: {
      type: Array,
      default: () => [
        'no_cancel', 'large', 'primary', 'montserrat_alternates',
      ],
    },
  },
  data() {
    return {
      activeMenu: undefined,
    };
  },
  created() {
    if (this.$props.menuItems) {
      this.activeMenu = this.$props.menuItems[0].prop;
    }
  },
};
</script>

<style lang="scss" scoped>
.modal {
  z-index: 100;
  position: fixed;
  top: 0;
  left: 0;
  min-height: 100vh;
  min-width: 100vw;
  display: flex;
  justify-content: center;
  align-items: center;

  &-overlay {
    z-index: 100;
    position: fixed;
    top: 0;
    left: 0;
    height: 100vh;
    width: 100vw;
    overflow: hidden;
    background: #000;
    opacity: 0.9;
  }

  &-content {
    z-index: 101;
    box-sizing: border-box;
    padding: 30px;
    width: 770px;
    background: #fff;
    border-radius: 5px;

    .header {
      margin-bottom: 20px;
      padding: 0 10px;
      display: flex;
      justify-content: flex-start;
      align-items: center;

      &-title {
        font-family: $montserrat;
        font-size: 24px;
        color: #000;
      }

      &-menu {
        display: flex;
        align-items: center;

        .menu {

          &-divider {
            margin: 0 10px;
            height: 30px;
            width: 3px;
            border-radius: 5px;
            background: $primary;
          }

        }

      }

      &-action {
        height: 35px;
        width: 35px;
        margin-left: auto;
        justify-self: flex-end;
        display: flex;
        justify-content: center;
        align-items: center;
        background: none;
        color: $primary;
        font-family: $firaSans;
        border-radius: 5px;
        border: 1px solid $primary;
        transition: all ease-in-out .2s;

        &:hover {
          background: $primary;
          color: #fff;
          cursor: pointer;
        }

      }

    }

  }

}
</style>
